/*
 * Copyright (C) 1990-99 DMS Decision Management Systems Ges.m.b.H.
 * Copyright (C) 2001    Erwin Bolwidt, Haarlem, The Netherlands.
 *
 * The original author of this file is DMS; refactorings, bug fixes and
 * extensions were done by Erwin Bolwidt.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

package at.dms.kjc;

import at.dms.compiler.Compiler;

/**
 * Root for type hierarchy
 */
public class CStdType extends at.dms.util.Utils implements Constants
{

    public static CVoidType Void;
    public static CNullType Null;

    public static CNumericType Byte;
    public static CNumericType Integer;
    public static CNumericType Long;
    public static CNumericType Double;
    public static CNumericType Float;
    public static CNumericType Short;
    public static CNumericType Char;

    public static CBooleanType Boolean;

    public static CClassType Object;
    public static CClassType Class;
    public static CClassType String;
    public static CClassType Throwable;
    public static CClassType Exception;
    public static CClassType Error;
    public static CClassType RuntimeException;

    public static CArrayType CharArray;


    /**
     * Initialize all constants
     */
    public static void init(Compiler compiler)
    {
        // one time is enough
        if (Void == null) {
            Void = new CVoidType();
            Null = new CNullType();

            Byte = new CNumericType(TID_BYTE);
            Integer = new CNumericType(TID_INT);
            Long = new CNumericType(TID_LONG);
            Double = new CNumericType(TID_DOUBLE);
            Float = new CNumericType(TID_FLOAT);
            Short = new CNumericType(TID_SHORT);
            Char = new CNumericType(TID_CHAR);

            Boolean = new CBooleanType();
      
            Object = CClassType.lookup(Constants.JAV_OBJECT);
            Class = CClassType.lookup(Constants.JAV_CLASS);
            String = CClassType.lookup(Constants.JAV_STRING);
            Throwable = CClassType.lookup(Constants.JAV_THROWABLE);
            Exception = CClassType.lookup(Constants.JAV_EXCEPTION);
            Error = CClassType.lookup(Constants.JAV_ERROR);
            RuntimeException =
                CClassType.lookup(Constants.JAV_RUNTIME_EXCEPTION);

            CharArray = new CArrayType(Char, 1);
        }
    }
}
