/*
 * Copyright (C) 1990-99 DMS Decision Management Systems Ges.m.b.H.
 * Copyright (C) 2001    Erwin Bolwidt, Haarlem, The Netherlands.
 *
 * The original author of this file is DMS; refactorings, bug fixes and
 * extensions were done by Erwin Bolwidt.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

package at.dms.kjc;

/**
 * Defines all constants shared by compiler
 */
public interface Constants extends at.dms.classfile.Constants
{
    /**
     * Type constant for 'void' type.
     */
    int TID_VOID    = 1;

    /**
     * Type constant for 'byte' type.
     */
    int TID_BYTE    = 2;

    /**
     * Type constant for 'short' type.
     */
    int TID_SHORT   = 3;

    /**
     * Type constant for 'char' type.
     */
    int TID_CHAR    = 4;

    /**
     * Type constant for 'int' type.
     */
    int TID_INT     = 5;

    /**
     * Type constant for 'long' type.
     */
    int TID_LONG    = 6;

    /**
     * Type constant for 'float' type.
     */
    int TID_FLOAT   = 7;

    /**
     * Type constant for 'double' type.
     */
    int TID_DOUBLE  = 8;

    /**
     * Type constant for java.lang.Class type.
     */
    int TID_CLASS   = 9;

    /**
     * Type constant for all arrays.
     */
    int TID_ARRAY   = 10;

    /**
     * Type constant for 'boolean' type.
     */
    int TID_BOOLEAN = 11;

    /**
     *
     */
    int CMP_VERSION     = 0xC0DE01;

    String JAV_CLASS             = "java/lang/Class";

    String JAV_CLONEABLE         = "java/lang/Cloneable";

    String JAV_ERROR             = "java/lang/Error";
    String JAV_EXCEPTION         = "java/lang/Exception";
    String JAV_OBJECT            = "java/lang/Object";
    String JAV_RUNTIME_EXCEPTION = "java/lang/RuntimeException";
    String JAV_STRING            = "java/lang/String";
    String JAV_STRINGBUFFER      = "java/lang/StringBuffer";
    String JAV_THROWABLE         = "java/lang/Throwable";

    String JAV_CONSTRUCTOR       = "<init>";
    String JAV_INIT              = "Block$";
    String JAV_STATIC_INIT       = "<clinit>";

    String JAV_THIS              = "this";
    String JAV_OUTER_THIS        = "this$0";

    String JAV_NAME_SEPARATOR    = "/";
    String JAV_RUNTIME           = "java/lang";
    String JAV_CLONE             = "clone";
    String JAV_LENGTH            = "length";

    int OPE_SIMPLE   = 0;
    int OPE_PLUS     = 1;
    int OPE_MINUS    = 2;
    int OPE_STAR     = 3;
    int OPE_SLASH    = 4;
    int OPE_PERCENT  = 5;
    int OPE_SR       = 6;
    int OPE_BSR      = 7;
    int OPE_SL       = 8;
    int OPE_BAND     = 9;
    int OPE_BXOR     = 10;
    int OPE_BOR      = 11;
    int OPE_BNOT     = 12;
    int OPE_LNOT     = 13;
    int OPE_LT       = 14;
    int OPE_LE       = 15;
    int OPE_GT       = 16;
    int OPE_GE       = 17;
    int OPE_EQ       = 18;
    int OPE_NE       = 19;

    int OPE_PREINC   = 20;
    int OPE_PREDEC   = 21;
    int OPE_POSTINC  = 22;
    int OPE_POSTDEC  = 23;
}

