/*
 * Copyright (C) 1990-99 DMS Decision Management Systems Ges.m.b.H.
 * Copyright (C) 2001    Erwin Bolwidt, Haarlem, The Netherlands.
 *
 * The original author of this file is DMS; refactorings, bug fixes and
 * extensions were done by Erwin Bolwidt.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */
package at.dms.kjc;

import at.dms.compiler.CWarning;
import at.dms.compiler.WarningFilter;

/**
 * This is the default warning filter.
 */
public class DefaultFilter
    implements WarningFilter
{
    /**
     * The UNUSED_PARAMETER, CONSTANT_VARIABLE_NOT_FINAL and
     * UNUSED_CATCH_PARAMETER warnings are rejected by this warning filter.
     * All other warnings are accepted.
     *
     * @param warning
     * A warning to be filtered.
     *
     * @return
     * One of: FLT_REJECT, FLT_FORCE, FLT_ACCEPT
     */
    public int filter(CWarning warning)
    {
        if (warning.hasDescription(KjcMessages.UNUSED_PARAMETER)
            || warning.hasDescription(KjcMessages.CONSTANT_VARIABLE_NOT_FINAL)
            || warning.hasDescription(KjcMessages.UNUSED_CATCH_PARAMETER)) {
            return FLT_REJECT;
        }
        else {
            return FLT_ACCEPT;
        }
    }
}
