/*
 * ANTLR-generated file resulting from grammar src/at/dms/optgen/Optgen.g
 * 
 * Terence Parr, MageLang Institute
 * with John Lilley, Empathy Software
 * ANTLR Version 2.6.1; 1996-1999
 */

package at.dms.optgen;

import java.io.IOException;
import antlr.TokenBuffer;
import antlr.LLkParser;
import antlr.Token;
import antlr.TokenStream;
import antlr.ParserException;
import antlr.NoViableAltException;
import antlr.MismatchedTokenException;
import antlr.SemanticException;
import antlr.ParserSharedInputState;
import antlr.collections.impl.BitSet;

import java.util.ArrayList;
import java.util.List;

public class OptgenParser extends antlr.LLkParser
       implements OptgenTokenTypes
 {

protected OptgenParser(TokenBuffer tokenBuf, int k) {
  super(tokenBuf,k);
  tokenNames = _tokenNames;
}

public OptgenParser(TokenBuffer tokenBuf) {
  this(tokenBuf,2);
}

protected OptgenParser(TokenStream lexer, int k) {
  super(lexer,k);
  tokenNames = _tokenNames;
}

public OptgenParser(TokenStream lexer) {
  this(lexer,2);
}

public OptgenParser(ParserSharedInputState state) {
  super(state,2);
  tokenNames = _tokenNames;
}

	public final DefinitionFile  aCompilationUnit(
		String sourceFile
	) throws ParserException, IOException {
		DefinitionFile self;
		
		
		String prefix = null;
		String parent = null;
		String packageName = null;
		String version = null;
		String usage = null;
		//  String help = null; // no longer used.
		List definitions = new ArrayList();
		OptionDefinition def;
		
		
		match(LITERAL_prefix);
		prefix=aIdentifier();
		{
		switch ( LA(1)) {
		case LITERAL_parent:
		{
			match(LITERAL_parent);
			parent=aName();
			break;
		}
		case LITERAL_version:
		case LITERAL_usage:
		case LITERAL_package:
		case LITERAL_longname:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		{
		switch ( LA(1)) {
		case LITERAL_version:
		{
			match(LITERAL_version);
			version=aString();
			break;
		}
		case LITERAL_usage:
		case LITERAL_package:
		case LITERAL_longname:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		{
		switch ( LA(1)) {
		case LITERAL_usage:
		{
			match(LITERAL_usage);
			usage=aString();
			break;
		}
		case LITERAL_package:
		case LITERAL_longname:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		{
		switch ( LA(1)) {
		case LITERAL_package:
		{
			match(LITERAL_package);
			packageName=aName();
			break;
		}
		case LITERAL_longname:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		{
		int _cnt7=0;
		_loop7:
		do {
			if ((LA(1)==LITERAL_longname)) {
				def=aOptionDefinition();
				definitions.add(def);
			}
			else {
				if ( _cnt7>=1 ) { break _loop7; } else {throw new NoViableAltException(LT(1));}
			}
			
			_cnt7++;
		} while (true);
		}
		
		self = new DefinitionFile(sourceFile, packageName, parent, prefix, 
		version, usage, definitions); 
		
		return self;
	}
	
	public final String  aIdentifier(
		
	) throws ParserException, IOException {
		String self = null;
		
		Token  t = null;
		
		t = LT(1);
		match(IDENT);
		self = t.getText();
		return self;
	}
	
	public final String  aName(
		
	) throws ParserException, IOException {
		String self;
		
		
		String ident;
		
		
		ident=aIdentifier();
		self = ident;
		{
		_loop11:
		do {
			if ((LA(1)==DOT)) {
				match(DOT);
				ident=aIdentifier();
				self += "." + ident;
			}
			else {
				break _loop11;
			}
			
		} while (true);
		}
		return self;
	}
	
	public final String  aString(
		
	) throws ParserException, IOException {
		String self;
		
		Token  t = null;
		
		t = LT(1);
		match(STRING);
		self = t.getText();
		return self;
	}
	
	public final OptionDefinition  aOptionDefinition(
		
	) throws ParserException, IOException {
		OptionDefinition self;
		
		
		String longname;
		String shortname;
		String type;
		String defaultValue;
		String argument = null;
		String help;
		
		
		match(LITERAL_longname);
		longname=aString();
		match(LITERAL_shortcut);
		shortname=aString();
		match(LITERAL_type);
		type=aOptionType();
		match(LITERAL_default);
		defaultValue=aString();
		{
		switch ( LA(1)) {
		case LITERAL_optionalDefault:
		{
			match(LITERAL_optionalDefault);
			argument=aString();
			break;
		}
		case LITERAL_requireArgument:
		{
			match(LITERAL_requireArgument);
			argument = "";
			break;
		}
		case LITERAL_help:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		match(LITERAL_help);
		help=aString();
		
		self = new OptionDefinition(longname, shortname, type,
		defaultValue, argument, help);
		
		return self;
	}
	
	public final String  aOptionType(
		
	) throws ParserException, IOException {
		String self;
		
		
		switch ( LA(1)) {
		case LITERAL_int:
		{
			match(LITERAL_int);
			self = "int";
			break;
		}
		case LITERAL_boolean:
		{
			match(LITERAL_boolean);
			self = "boolean";
			break;
		}
		case LITERAL_String:
		{
			match(LITERAL_String);
			self = "String";
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		return self;
	}
	
	
	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"\"prefix\"",
		"\"parent\"",
		"\"version\"",
		"\"usage\"",
		"\"package\"",
		"IDENT",
		"DOT",
		"STRING",
		"\"longname\"",
		"\"shortcut\"",
		"\"type\"",
		"\"default\"",
		"\"optionalDefault\"",
		"\"requireArgument\"",
		"\"help\"",
		"\"int\"",
		"\"boolean\"",
		"\"String\""
	};
	
	
	}
