/*
 * Copyright (C) 1990-99 DMS Decision Management Systems Ges.m.b.H.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */
package at.dms.util;

import java.util.Vector;
import java.util.LinkedList;

/**
 * This class implements a cache of char arrays.
 */
public class VectorCache
{
    /**
     * Constant for small Vectors.
     */
    public static final int SMALL = 0;

    /**
     * Constant for big Vectors.
     */
    public static final int BIG = 1;

    /**
     * Small vectors.
     */
    private static LinkedList smalls = new LinkedList();

    /**
     * Big vectors.
     */
    private static LinkedList bigs = new LinkedList();

    /**
     * Returns a Vector.
     */
    public static synchronized Vector request(int size)
    {
        if (size == SMALL) {
            if (smalls.isEmpty()) {
                return new Vector();
            }
            else {
                return (Vector)smalls.removeFirst();
            }
        }
        else {
            if (bigs.isEmpty()) {
                return new Vector(100);
            }
            else {
                return (Vector)bigs.removeFirst();
            }
        }
    }

    /**
     * Releases a Vector.
     */
    public static void release(Vector vector)
    {
        vector.setSize(0);
        if (vector.capacity() >= 100) {
            bigs.addLast(vector);
        }
        else {
            smalls.addLast(vector);
        }
    }
}
